
  CREATE OR REPLACE FORCE EDITIONABLE VIEW "IGOPS"."SPERMISSION_DATA_UPDATE_V" ("CUR_ID", "COL_ID", "CUR_TIME", "CUR_ACCOUNT_GRANT", "COL_ACCOUNT_GRANT", "CUR_ASSIGNABLE", "COL_ASSIGNABLE", "CUR_AUTHORITATIVE", "COL_AUTHORITATIVE", "CUR_BOUND_BY_ID", "COL_BOUND_BY_ID", "CUR_BOUNDABLE", "COL_BOUNDABLE", "CUR_COST", "COL_COST", "CUR_DELETED", "COL_DELETED", "CUR_DESCRIPTION", "COL_DESCRIPTION", "CUR_DISPLAY_NAME", "COL_DISPLAY_NAME", "CUR_DRIVER_ID", "COL_DRIVER_ID", "CUR_EFFECTIVE", "COL_EFFECTIVE", "CUR_EXCLUDE_FROM_CATALOG", "COL_EXCLUDE_FROM_CATALOG", "CUR_IS_CURATED", "COL_IS_CURATED", "CUR_LOGICAL_ID", "COL_LOGICAL_ID", "CUR_MERGED", "COL_MERGED", "CUR_NAME", "COL_NAME", "CUR_NOT_REVIEWABLE", "COL_NOT_REVIEWABLE", "CUR_OWNER", "COL_OWNER", "CUR_PERMISSION_ID", "COL_PERMISSION_ID", "CUR_PROV_ATTRIBUTE", "COL_PROV_ATTRIBUTE", "CUR_PROV_BY_UNIQUE_PERM_ID", "COL_PROV_BY_UNIQUE_PERM_ID", "CUR_PROV_NATIVE_VALUE", "COL_PROV_NATIVE_VALUE", "CUR_PROV_UNIQUE_DRIVER_ID", "COL_PROV_UNIQUE_DRIVER_ID", "CUR_PROVISIONABLE", "COL_PROVISIONABLE", "CUR_RISK", "COL_RISK", "CUR_TYPE", "COL_TYPE", "CUR_UNIQUE_BOUND_BY_ID", "COL_UNIQUE_BOUND_BY_ID", "CUR_UNIQUE_PERMISSION_ID", "COL_UNIQUE_PERMISSION_ID", "CUR_VALUE", "COL_VALUE", "CUR_VALUE_TYPE", "COL_VALUE_TYPE", "CUR_APPLICATION", "COL_APPLICATION", "CUR_BASE_APPLICATION", "COL_BASE_APPLICATION", "CUR_COLLECTED_ENTITY", "COL_COLLECTED_ENTITY", "CUR_DATA_COLLECTION", "COL_DATA_COLLECTION", "CUR_EFFECTIVE_ENTITY", "COL_EFFECTIVE_ENTITY", "CUR_SVERSION", "COL_SVERSION", "CUR_AUTO_GENERATED", "COL_AUTO_GENERATED", "CUR_PROV_UNIQUE_PERMISSION_ID", "COL_PROV_UNIQUE_PERMISSION_ID", "CUR_STATIC_PERMISSION", "COL_STATIC_PERMISSION", "CUR_PHOTO_URI", "COL_PHOTO_URI", "CUR_PHOTO_FORMAT", "COL_PHOTO_FORMAT", "CUR_PHOTO_RECORD", "COL_PHOTO_RECORD", "APP_NAME", "CURATED", "COLLECTED") AS 
  SELECT sp.id cur_id,
sper.id col_id,
MAX(ec.timestamp) cur_time,
sp.account_grant cur_account_grant,
sper.account_grant col_account_grant,
sp.assignable cur_assignable,
sper.assignable col_assignable,
sp.authoritative cur_authoritative,
sper.authoritative col_authoritative,
TO_CHAR(sp.bound_by_id) cur_bound_by_id,
TO_CHAR(sper.bound_by_id) col_bound_by_id,
sp.boundable cur_boundable,
sper.boundable col_boundable,
sp.cost cur_cost,
sper.cost col_cost,
sp.deleted cur_deleted,
sper.deleted col_deleted,
sp.description cur_description,
sper.description col_description,
sp.display_name cur_display_name,
sper.display_name col_display_name,
sp.driver_id cur_driver_id,
sper.driver_id col_driver_id,
sp.effective cur_effective,
sper.effective col_effective,
sp.exclude_from_catalog cur_exclude_from_catalog,
sper.exclude_from_catalog col_exclude_from_catalog,
sp.is_curated cur_is_curated,
sper.is_curated col_is_curated,
sp.logical_id cur_logical_id,
sper.logical_id col_logical_id,
sp.merged cur_merged,
sper.merged col_merged,
sp.name cur_name,
sper.name col_name,
sp.not_reviewable cur_not_reviewable,
sper.not_reviewable col_not_reviewable,
cur_get.cur_owner,
col_get.col_owner,
TO_CHAR(sp.permission_id) cur_permission_id,
TO_CHAR(sper.permission_id) col_permission_id,
sp.prov_attribute cur_prov_attribute,
sper.prov_attribute col_prov_attribute,
sp.prov_by_unique_permission_id cur_prov_by_unique_perm_id,
sper.prov_by_unique_permission_id col_prov_by_unique_perm_id,
sp.prov_native_value cur_prov_native_value,
sper.prov_native_value col_prov_native_value,
sp.prov_unique_driver_id cur_prov_unique_driver_id,
sper.prov_unique_driver_id col_prov_unique_driver_id,
sp.provisionable cur_provisionable,
sper.provisionable col_provisionable,
sp.risk cur_risk,
sper.risk col_risk,
sp.type cur_type,
sper.type col_type,
sp.unique_bound_by_id cur_unique_bound_by_id,
sper.unique_bound_by_id col_unique_bound_by_id,
sp.unique_permission_id cur_unique_permission_id,
sper.unique_permission_id col_unique_permission_id,
sp.value cur_value,
sper.value col_value,
sp.value_type cur_value_type,
sper.value_type col_value_type,
sp.application cur_application,
sper.application col_application,
sp.base_application cur_base_application,
sper.base_application col_base_application,
sp.collected_entity cur_collected_entity,
sper.collected_entity col_collected_entity,
sp.data_collection cur_data_collection,
sper.data_collection col_data_collection,
sp.effective_entity cur_effective_entity,
sper.effective_entity col_effective_entity,
sp.sversion cur_sversion,
sper.sversion col_sversion,
sp.auto_generated cur_auto_generated,
sper.auto_generated col_auto_generated,
sp.prov_unique_permission_id cur_prov_unique_permission_id,
sper.prov_unique_permission_id col_prov_unique_permission_id,
sp.static_permission cur_static_permission,
sper.static_permission col_static_permission,
sp.photo_uri cur_photo_uri,
sper.photo_uri col_photo_uri,
sp.photo_format cur_photo_format,
sper.photo_format col_photo_format,
sp.photo_record cur_photo_record,
sper.photo_record col_photo_record,
sp.app_name,
( SELECT count(spermission.unique_permission_id) count
	FROM spermission
	WHERE spermission.deleted = 0 AND spermission.is_curated = 1) curated,
( SELECT count(spermission.unique_permission_id) count
	FROM spermission
	WHERE spermission.deleted = 0 AND spermission.is_curated = 0 AND spermission.effective = 1) collected
FROM spermission
LEFT JOIN ( SELECT spermission.id,
	spermission.account_grant,
	spermission.assignable,
	spermission.authoritative,
	spermission.bound_by_id,
	spermission.boundable,
	spermission.cost,
	spermission.deleted,
	spermission.description,
	spermission.display_name,
	spermission.driver_id,
	spermission.effective,
	spermission.exclude_from_catalog,
	spermission.is_curated,
	spermission.logical_id,
	spermission.merged,
	spermission.name,
	spermission.not_reviewable,
	spermission.permission_id,
	spermission.prov_attribute,
	spermission.prov_by_unique_permission_id,
	spermission.prov_native_value,
	spermission.prov_unique_driver_id,
	spermission.provisionable,
	spermission.risk,
	spermission.type,
	spermission.unique_bound_by_id,
	spermission.unique_permission_id,
	spermission.value,
	spermission.value_type,
	spermission.application,
	spermission.base_application,
	spermission.collected_entity,
	spermission.data_collection,
	spermission.effective_entity,
	spermission.sversion,
	spermission.auto_generated,
	spermission.prov_unique_permission_id,
	spermission.static_permission,
	spermission.photo_uri,
	spermission.photo_format,
	spermission.photo_record,
	ds.name app_name
	FROM spermission
	LEFT JOIN data_source ds ON spermission.application = ds.id
	WHERE spermission.is_curated = 1
	ORDER BY spermission.effective) sp ON sp.id = spermission.id
LEFT JOIN spermission spe ON TO_CHAR(spe.unique_permission_id) = TO_CHAR(sp.unique_permission_id) AND spe.effective = 1
LEFT JOIN spermission sper ON sper.collected_entity = spe.collected_entity AND sper.effective = 0
LEFT JOIN entity_change ec ON TO_CHAR(ec.unique_id) = TO_CHAR(sp.unique_permission_id) AND TO_CHAR(ec.change_type) = TO_CHAR('ALTERED')
LEFT JOIN (SELECT DISTINCT sp.unique_permission_id, sp.name, LISTAGG(TO_CHAR(sus.display_name), TO_CHAR(' | ')) WITHIN GROUP (ORDER BY sus.display_name) cur_owner FROM spermission sp LEFT JOIN resolved_spermission_owner rso ON rso.permission = sp.id LEFT JOIN (SELECT UNIQUE sus.display_name, rso2.id FROM suser sus LEFT JOIN resolved_spermission_owner rso2 ON sus.unique_user_id = rso2.owner_unique_id) sus ON sus.id = rso.id WHERE sus.display_name IS NOT NULL AND sp.is_curated = 1 GROUP BY sp.name, sp.unique_permission_id) cur_get
ON cur_get.unique_permission_id = sp.unique_permission_id
LEFT JOIN (SELECT DISTINCT sp.unique_permission_id, sp.name, LISTAGG(TO_CHAR(sus.display_name), TO_CHAR(' | ')) WITHIN GROUP (ORDER BY sus.display_name) col_owner FROM spermission sp LEFT JOIN resolved_spermission_owner rso ON rso.permission = sp.collected_entity LEFT JOIN (SELECT UNIQUE sus.display_name, rso2.id FROM suser sus LEFT JOIN resolved_spermission_owner rso2 ON sus.unique_user_id = rso2.owner_unique_id) sus ON sus.id = rso.id WHERE sus.display_name IS NOT NULL AND sp.merged = 0 GROUP BY sp.name, sp.unique_permission_id) col_get 
ON col_get.unique_permission_id = spermission.unique_permission_id
LEFT JOIN entity_photo ep ON ep.id = sp.photo_record
WHERE sper.unique_permission_id IS NOT NULL
GROUP BY sp.id, 
sper.id, 
sp.account_grant, 
sper.account_grant, 
sp.assignable, 
sper.assignable, 
sp.authoritative, 
sper.authoritative, 
TO_CHAR(sp.bound_by_id), 
TO_CHAR(sper.bound_by_id), 
sp.boundable, 
sper.boundable, 
sp.cost, 
sper.cost, 
sp.deleted, 
sper.deleted, 
sp.description, 
sper.description, 
sp.display_name, 
sper.display_name, 
sp.driver_id, 
sper.driver_id, 
sp.effective, 
sper.effective, 
sp.exclude_from_catalog, 
sper.exclude_from_catalog, 
sp.is_curated, 
sper.is_curated, 
sp.logical_id, 
sper.logical_id, 
sp.merged, 
sper.merged, 
sp.name, 
sper.name, 
sp.not_reviewable, 
sper.not_reviewable, 
cur_get.cur_owner,
col_get.col_owner,
TO_CHAR(sp.permission_id), 
TO_CHAR(sper.permission_id), 
sp.prov_attribute, 
sper.prov_attribute, 
sp.prov_by_unique_permission_id, 
sper.prov_by_unique_permission_id, 
sp.prov_native_value, 
sper.prov_native_value, 
sp.prov_unique_driver_id, 
sper.prov_unique_driver_id, 
sp.provisionable, 
sper.provisionable, 
sp.risk, 
sper.risk, 
sp.type, 
sper.type, 
sp.unique_bound_by_id, 
sper.unique_bound_by_id, 
sp.unique_permission_id, 
sper.unique_permission_id, 
sp.value, 
sper.value, 
sp.value_type, 
sper.value_type, 
sp.application, 
sper.application, 
sp.base_application, 
sper.base_application, 
sp.collected_entity, 
sper.collected_entity, 
sp.data_collection, 
sper.data_collection, 
sp.effective_entity, 
sper.effective_entity, 
sp.sversion, 
sper.sversion, 
sp.auto_generated, 
sper.auto_generated, 
sp.prov_unique_permission_id, 
sper.prov_unique_permission_id, 
sp.static_permission, 
sper.static_permission, 
sp.photo_uri, 
sper.photo_uri,
sp.photo_format,
sper.photo_format,
sp.photo_record,
sper.photo_record,
sp.app_name
ORDER BY sper.name;

  GRANT SELECT ON igops.SPERMISSION_DATA_UPDATE_V TO igrptuser;
CREATE OR REPLACE PUBLIC SYNONYM SPERMISSION_DATA_UPDATE_V for igops.SPERMISSION_DATA_UPDATE_V;
