CREATE OR REPLACE VIEW public.saccount_data_update_v AS 
SELECT DISTINCT sa.id AS cur_id,
    sacc.id AS col_id,
    sa.account_id AS cur_account_id,
    sacc.account_id AS col_account_id,
    sa.conn_acct_id AS cur_conn_acct_id,
    sacc.conn_acct_id AS col_conn_acct_id,
    sa.cost AS cur_cost,
    sacc.cost AS col_cost,
    sa.deleted AS cur_deleted,
    sacc.deleted AS col_deleted,
    sa.description AS cur_description,
    sacc.description AS col_description,
    sa.disabled AS cur_disabled,
    sacc.disabled AS col_disabled,
    sa.driver_id AS cur_driver_id,
    sacc.driver_id AS col_driver_id,
    sa.effective AS cur_effective,
    sacc.effective AS col_effective,
    sa.is_curated AS cur_is_curated,
    sacc.is_curated AS col_is_curated,
    sa.last_login AS cur_last_login,
    sacc.last_login AS col_last_login,
    sa.logical_id AS cur_logical_id,
    sacc.logical_id AS col_logical_id,
    sa.merged AS cur_merged,
    sacc.merged AS col_merged,
    sa.name AS cur_name,
    sacc.name AS col_name,
    sa.privileged AS cur_privileged,
    sacc.privileged AS col_privileged,
    sa.relation_to_user_type AS cur_relation_to_user_type,
    sacc.relation_to_user_type AS col_relation_to_user_type,
    sa.risk AS cur_risk,
    sacc.risk AS col_risk,
    sa.state AS cur_state,
    sacc.state AS col_state,
    sa.type AS cur_type,
    sacc.type AS col_type,
    sa.unique_account_id AS cur_unique_account_id,
    sacc.unique_account_id AS col_unique_account_id,
    sa.user_id AS cur_user_id,
    sacc.user_id AS col_user_id,
    sa.virtual AS cur_virtual,
    sacc.virtual AS col_virtual,
    sa.application AS cur_application,
    sacc.application AS col_application,
    sa.base_application AS cur_base_application,
    sacc.base_application AS col_base_application,
    sa.collected_entity AS cur_collected_entity,
    sacc.collected_entity AS col_collected_entity,
    sa.data_collection AS cur_data_collection,
    sacc.data_collection AS col_data_collection,
    sa.effective_entity AS cur_effective_entity,
    sacc.effective_entity AS col_effective_entity,
    sa.suser AS cur_suser,
    sacc.suser AS col_suser,
    sa.sversion AS cur_sversion,
    sacc.sversion AS col_sversion,
    sa.classification_id AS cur_classification_id,
    sacc.classification_id AS col_classification_id,
    sa.last_orphan_review AS cur_last_orphan_review,
    sacc.last_orphan_review AS col_last_orphan_review,
    sa.last_account_review AS cur_last_account_review,
    sacc.last_account_review AS col_last_account_review,
    sa.login_count AS cur_login_count,
    sacc.login_count AS col_login_count,
    sa.app_name,
    ( SELECT count(saccount.unique_account_id) AS count
           FROM saccount
          WHERE saccount.deleted = false AND saccount.is_curated = true) AS curated,
    ( SELECT count(saccount.unique_account_id) AS count
           FROM saccount
          WHERE saccount.deleted = false AND saccount.is_curated = false AND saccount.effective = true) AS collected
   FROM ( SELECT DISTINCT saccount.id,
            saccount.account_id,
            saccount.conn_acct_id,
            saccount.cost,
            saccount.deleted,
            saccount.description,
            saccount.disabled,
            saccount.driver_id,
            saccount.effective,
            saccount.is_curated,
            saccount.last_login,
            saccount.logical_id,
            saccount.merged,
            saccount.name,
            saccount.privileged,
            saccount.relation_to_user_type,
            saccount.risk,
            saccount.state,
            saccount.type,
            saccount.unique_account_id,
            saccount.user_id,
            saccount.virtual,
            saccount.application,
            saccount.base_application,
            saccount.collected_entity,
            saccount.data_collection,
            saccount.effective_entity,
            saccount.suser,
            saccount.sversion,
            saccount.classification_id,
            saccount.last_orphan_review,
            saccount.last_account_review,
            saccount.login_count,
            ds.name AS app_name
           FROM saccount
             LEFT JOIN data_source ds ON saccount.application = ds.id
             LEFT JOIN saccount sac_1 ON sac_1.unique_account_id::text = saccount.unique_account_id::text AND sac_1.is_curated = true
          WHERE saccount.is_curated = true
          ORDER BY saccount.effective) sa
     LEFT JOIN saccount sac ON sac.unique_account_id::text = sa.unique_account_id::text AND sac.effective = true
     LEFT JOIN saccount sacc ON sacc.collected_entity = sac.collected_entity AND sacc.effective = false
  ORDER BY sacc.name;

  ALTER TABLE public.saccount_data_update_v
  OWNER TO igops;
GRANT ALL ON TABLE public.saccount_data_update_v TO igops;
GRANT SELECT ON TABLE public.saccount_data_update_v TO ig_report_role;
