CREATE OR REPLACE VIEW public.spermission_data_update_v AS 
 SELECT sp.id AS cur_id,
    sper.id AS col_id,
    max(ec."timestamp") AS cur_time,
    sp.account_grant AS cur_account_grant,
    sper.account_grant AS col_account_grant,
    sp.assignable AS cur_assignable,
    sper.assignable AS col_assignable,
    sp.authoritative AS cur_authoritative,
    sper.authoritative AS col_authoritative,
    sp.bound_by_id AS cur_bound_by_id,
    sper.bound_by_id AS col_bound_by_id,
    sp.boundable AS cur_boundable,
    sper.boundable AS col_boundable,
    sp.cost AS cur_cost,
    sper.cost AS col_cost,
    sp.deleted AS cur_deleted,
    sper.deleted AS col_deleted,
    sp.description AS cur_description,
    sper.description AS col_description,
    sp.display_name AS cur_display_name,
    sper.display_name AS col_display_name,
    sp.driver_id AS cur_driver_id,
    sper.driver_id AS col_driver_id,
    sp.effective AS cur_effective,
    sper.effective AS col_effective,
    sp.exclude_from_catalog AS cur_exclude_from_catalog,
    sper.exclude_from_catalog AS col_exclude_from_catalog,
    sp.is_curated AS cur_is_curated,
    sper.is_curated AS col_is_curated,
    sp.logical_id AS cur_logical_id,
    sper.logical_id AS col_logical_id,
    sp.merged AS cur_merged,
    sper.merged AS col_merged,
    sp.name AS cur_name,
    sper.name AS col_name,
    sp.not_reviewable AS cur_not_reviewable,
    sper.not_reviewable AS col_not_reviewable,
    string_agg(DISTINCT su.display_name::text, ' | '::text) AS cur_owner,
    string_agg(DISTINCT sus.display_name::text, ' | '::text) AS col_owner,
    sp.permission_id AS cur_permission_id,
    sper.permission_id AS col_permission_id,
    sp.prov_attribute AS cur_prov_attribute,
    sper.prov_attribute AS col_prov_attribute,
    sp.prov_by_unique_permission_id AS cur_prov_by_unique_perm_id,
    sper.prov_by_unique_permission_id AS col_prov_by_unique_perm_id,
    sp.prov_native_value AS cur_prov_native_value,
    sper.prov_native_value AS col_prov_native_value,
    sp.prov_unique_driver_id AS cur_prov_unique_driver_id,
    sper.prov_unique_driver_id AS col_prov_unique_driver_id,
    sp.provisionable AS cur_provisionable,
    sper.provisionable AS col_provisionable,
    sp.risk AS cur_risk,
    sper.risk AS col_risk,
    sp.type AS cur_type,
    sper.type AS col_type,
    sp.unique_bound_by_id AS cur_unique_bound_by_id,
    sper.unique_bound_by_id AS col_unique_bound_by_id,
    sp.unique_permission_id AS cur_unique_permission_id,
    sper.unique_permission_id AS col_unique_permission_id,
    sp.value AS cur_value,
    sper.value AS col_value,
    sp.value_type AS cur_value_type,
    sper.value_type AS col_value_type,
    sp.application AS cur_application,
    sper.application AS col_application,
    sp.base_application AS cur_base_application,
    sper.base_application AS col_base_application,
    sp.collected_entity AS cur_collected_entity,
    sper.collected_entity AS col_collected_entity,
    sp.data_collection AS cur_data_collection,
    sper.data_collection AS col_data_collection,
    sp.effective_entity AS cur_effective_entity,
    sper.effective_entity AS col_effective_entity,
    sp.sversion AS cur_sversion,
    sper.sversion AS col_sversion,
    sp.auto_generated AS cur_auto_generated,
    sper.auto_generated AS col_auto_generated,
    sp.prov_unique_permission_id AS cur_prov_unique_permission_id,
    sper.prov_unique_permission_id AS col_prov_unique_permission_id,
    sp.static_permission AS cur_static_permission,
    sper.static_permission AS col_static_permission,
    sp.photo_uri AS cur_photo_uri,
    sper.photo_uri AS col_photo_uri,
    sp.photo_format AS cur_photo_format,
    sper.photo_format AS col_photo_format,
    sp.photo_record AS cur_photo_record,
    sper.photo_record AS col_photo_record,
    sp.app_name,
    ( SELECT count(spermission_1.unique_permission_id) AS count
           FROM spermission spermission_1
          WHERE spermission_1.deleted = false AND spermission_1.is_curated = true) AS curated,
    ( SELECT count(spermission_1.unique_permission_id) AS count
           FROM spermission spermission_1
          WHERE spermission_1.deleted = false AND spermission_1.is_curated = false AND spermission_1.effective = true) AS collected
   FROM spermission
     LEFT JOIN ( SELECT spermission_1.id,
            spermission_1.account_grant,
            spermission_1.assignable,
            spermission_1.authoritative,
            spermission_1.bound_by_id,
            spermission_1.boundable,
            spermission_1.cost,
            spermission_1.deleted,
            spermission_1.description,
            spermission_1.display_name,
            spermission_1.driver_id,
            spermission_1.effective,
            spermission_1.exclude_from_catalog,
            spermission_1.is_curated,
            spermission_1.logical_id,
            spermission_1.merged,
            spermission_1.name,
            spermission_1.not_reviewable,
            spermission_1.permission_id,
            spermission_1.prov_attribute,
            spermission_1.prov_by_unique_permission_id,
            spermission_1.prov_native_value,
            spermission_1.prov_unique_driver_id,
            spermission_1.provisionable,
            spermission_1.risk,
            spermission_1.type,
            spermission_1.unique_bound_by_id,
            spermission_1.unique_permission_id,
            spermission_1.value,
            spermission_1.value_type,
            spermission_1.application,
            spermission_1.base_application,
            spermission_1.collected_entity,
            spermission_1.data_collection,
            spermission_1.effective_entity,
            spermission_1.sversion,
            spermission_1.auto_generated,
            spermission_1.prov_unique_permission_id,
            spermission_1.static_permission,
            spermission_1.photo_uri,
            spermission_1.photo_format,
            spermission_1.photo_record,
            ds.name AS app_name
           FROM spermission spermission_1
             LEFT JOIN data_source ds ON spermission_1.application = ds.id
          WHERE spermission_1.is_curated = true
          ORDER BY spermission_1.effective) sp ON sp.id = spermission.id
     LEFT JOIN spermission spe ON spe.unique_permission_id::text = sp.unique_permission_id::text AND spe.effective = true
     LEFT JOIN spermission sper ON sper.collected_entity = spe.collected_entity AND sper.effective = false
     LEFT JOIN entity_change ec ON ec.unique_id::text = sp.unique_permission_id::text AND ec.change_type::text = 'ALTERED'::text
     LEFT JOIN ( SELECT DISTINCT rso.owner_unique_id,
            rso.permission AS rwo_permission_id,
            sp_1.id,
            sp_1.collected_entity
           FROM resolved_spermission_owner rso
             LEFT JOIN spermission sp_1 ON rso.permission = sp_1.id) cur_get ON cur_get.id = spermission.id
     LEFT JOIN ( SELECT DISTINCT rso.owner_unique_id,
            rso.permission AS rwo_permission_id,
            sp_1.id,
            sp_1.collected_entity
           FROM resolved_spermission_owner rso
             LEFT JOIN spermission sp_1 ON rso.permission = sp_1.collected_entity) col_get ON col_get.collected_entity = sper.id
     LEFT JOIN suser su ON su.unique_user_id::text = cur_get.owner_unique_id::text
     LEFT JOIN suser sus ON sus.unique_user_id::text = col_get.owner_unique_id::text
  WHERE sper.unique_permission_id IS NOT NULL
  GROUP BY sp.id, sper.id, sp.account_grant, sper.account_grant, sp.assignable, sper.assignable, sp.authoritative, sper.authoritative, sp.bound_by_id, sper.bound_by_id, sp.boundable, sper.boundable, sp.cost, sper.cost, sp.deleted, sper.deleted, sp.description, sper.description, sp.display_name, sper.display_name, sp.driver_id, sper.driver_id, sp.effective, sper.effective, sp.exclude_from_catalog, sper.exclude_from_catalog, sp.is_curated, sper.is_curated, sp.logical_id, sper.logical_id, sp.merged, sper.merged, sp.name, sper.name, sp.not_reviewable, sper.not_reviewable, sp.permission_id, sper.permission_id, sp.prov_attribute, sper.prov_attribute, sp.prov_by_unique_permission_id, sper.prov_by_unique_permission_id, sp.prov_native_value, sper.prov_native_value, sp.prov_unique_driver_id, sper.prov_unique_driver_id, sp.provisionable, sper.provisionable, sp.risk, sper.risk, sp.type, sper.type, sp.unique_bound_by_id, sper.unique_bound_by_id, sp.unique_permission_id, sper.unique_permission_id, sp.value, sper.value, sp.value_type, sper.value_type, sp.application, sper.application, sp.base_application, sper.base_application, sp.collected_entity, sper.collected_entity, sp.data_collection, sper.data_collection, sp.effective_entity, sper.effective_entity, sp.sversion, sper.sversion, sp.auto_generated, sper.auto_generated, sp.prov_unique_permission_id, sper.prov_unique_permission_id, sp.static_permission, sper.static_permission, sp.photo_uri, sper.photo_uri, sp.photo_format, sper.photo_format, sp.photo_record, sper.photo_record, sp.app_name
  ORDER BY sper.name;

ALTER TABLE public.spermission_data_update_v
  OWNER TO igops;
GRANT ALL ON TABLE public.spermission_data_update_v TO igops;
GRANT SELECT ON TABLE public.spermission_data_update_v TO ig_report_role;
