CREATE OR REPLACE VIEW public.suser_data_update_v AS 
 SELECT DISTINCT su.id AS cur_id,
    sus.id AS col_id,
    max(ec."timestamp") AS cur_time,
    su.deleted AS cur_deleted,
    sus.deleted AS col_deleted,
    su.department AS cur_department,
    sus.department AS col_department,
    su.display_description AS cur_display_description,
    sus.display_description AS col_display_description,
    su.display_name AS cur_display_name,
    sus.display_name AS col_display_name,
    su.dn AS cur_dn,
    sus.dn AS col_dn,
    su.effective AS cur_effective,
    sus.effective AS col_effective,
    su.email AS cur_email,
    semail.email AS col_email,
    su.employee_status AS cur_employee_status,
    sus.employee_status AS col_employee_status,
    su.employee_type AS cur_employee_type,
    sus.employee_type AS col_employee_type,
    su.first_name AS cur_first_name,
    sus.first_name AS col_first_name,
    su.full_name AS cur_full_name,
    sus.full_name AS col_full_name,
    su.guid AS cur_guid,
    sus.guid AS col_guid,
    su.home_phone AS cur_home_phone,
    sus.home_phone AS col_home_phone,
    su.idm_dn AS cur_idm_dn,
    sus.idm_dn AS col_idm_dn,
    su.idm_tree_name AS cur_idm_tree_name,
    sus.idm_tree_name AS col_idm_tree_name,
    su.is_curated AS cur_is_curated,
    sus.is_curated AS col_is_curated,
    su.job_code AS cur_job_code,
    sus.job_code AS col_job_code,
    su.job_title AS cur_job_title,
    sus.job_title AS col_job_title,
    su.last_name AS cur_last_name,
    sus.last_name AS col_last_name,
    su.location AS cur_location,
    sus.location AS col_location,
    su.merged AS cur_merged,
    sus.merged AS col_merged,
    su.middle_name AS cur_middle_name,
    sus.middle_name AS col_middle_name,
    su.office_phone AS cur_office_phone,
    sus.office_phone AS col_office_phone,
    su.other_phone AS cur_other_phone,
    sus.other_phone AS col_other_phone,
    su.preferred_locale AS cur_preferred_locale,
    sus.preferred_locale AS col_preferred_locale,
    su.provisioning_id AS cur_provisioning_id,
    sus.provisioning_id AS col_provisioning_id,
    su.risk AS cur_risk,
    sus.risk AS col_risk,
    su.secondary_supervisor_id AS cur_secondary_supervisor_id,
    sus.secondary_supervisor_id AS col_secondary_supervisor_id,
    su.supervisor_attr_key AS cur_supervisor_attr,
    sus.supervisor_attr_key AS col_supervisor_attr,
    su.supervisor_id AS cur_supervisor_id,
    sus.supervisor_id AS col_supervisor_id,
    su.supervisor_unique_id AS cur_supervisor_unique_id,
    sus.supervisor_unique_id AS col_supervisor_unique_id,
    ( SELECT soup.display_name
           FROM suser soup
          WHERE su.supervisor_unique_id::text = soup.unique_user_id::text
         LIMIT 1) AS cur_supervisor_name,
    ( SELECT soup.display_name
           FROM suser soup
          WHERE sus.supervisor_unique_id::text = soup.unique_user_id::text
         LIMIT 1) AS col_supervisor_name,
    su.unique_user_id AS cur_unique_user_id,
    sus.unique_user_id AS col_unique_user_id,
    su.user_id AS cur_user_id,
    sus.user_id AS col_user_id,
    su.business_unit AS cur_business_unit,
    sus.business_unit AS col_business_unit,
    su.collected_entity AS cur_collected_entity,
    sus.collected_entity AS col_collected_entity,
    su.effective_entity AS cur_effective_entity,
    sus.effective_entity AS col_effective_entity,
    su.identity_source AS cur_identity_source,
    sus.identity_source AS col_identity_source,
    su.sversion AS cur_sversion,
    sus.sversion AS col_sversion,
    su.workforce_id AS cur_workforce_id,
    sus.workforce_id AS col_workforce_id,
    su.photo_uri AS cur_photo_uri,
    sus.photo_uri AS col_photo_uri,
    su.photo_format AS cur_photo_format,
    sus.photo_format AS col_photo_format,
    su.photo_record AS cur_photo_record,
    sus.photo_record AS col_photo_record,
    su.identity_source_name,
    su.affiliated_id AS cur_affiliated_id,
    sus.affiliated_id AS col_affiliated_id,
    ( SELECT count(suser.unique_user_id) AS count
           FROM suser
          WHERE suser.deleted = false AND suser.is_curated = true) AS curated,
    ( SELECT count(suser.unique_user_id) AS count
           FROM suser
          WHERE suser.deleted = false AND suser.is_curated = false AND suser.effective = true) AS collected
   FROM ( SELECT DISTINCT suser.id,
            suser.deleted,
            suser.department,
            suser.display_description,
            suser.display_name,
            suser.dn,
            suser.effective,
            suser.employee_status,
            suser.employee_type,
            suser.first_name,
            suser.full_name,
            suser.guid,
            suser.home_phone,
            suser.idm_dn,
            suser.idm_tree_name,
            suser.is_curated,
            suser.job_code,
            suser.job_title,
            suser.last_name,
            suser.location,
            suser.merged,
            suser.middle_name,
            suser.office_phone,
            suser.other_phone,
            suser.preferred_locale,
            suser.provisioning_id,
            suser.secondary_supervisor_id,
            suser.supervisor_attr_key,
            suser.supervisor_id,
            suser.supervisor_unique_id,
            suser.unique_user_id,
            suser.user_id,
            suser.business_unit,
            suser.collected_entity,
            suser.effective_entity,
            suser.identity_source,
            suser.sversion,
            suser.workforce_id,
            suser.photo_uri,
            suser.photo_format,
            suser.photo_record,
            suser.risk,
            ds.name AS identity_source_name,
            string_agg(se.email::text, ' | '::text ORDER BY (se.email::text)) AS email,
            suser.affiliated_id
           FROM suser
             LEFT JOIN data_source ds ON suser.identity_source = ds.id
             LEFT JOIN suser_email se ON suser.id = se.suser
          WHERE suser.is_curated = true
          GROUP BY suser.id, suser.deleted, suser.department, suser.display_description, suser.display_name, suser.dn, suser.effective, suser.employee_status, suser.employee_type, suser.first_name, suser.full_name, suser.guid, suser.home_phone, suser.idm_dn, suser.idm_tree_name, suser.is_curated, suser.job_code, suser.job_title, suser.last_name, suser.location, suser.merged, suser.middle_name, suser.office_phone, suser.other_phone, suser.preferred_locale, suser.provisioning_id, suser.secondary_supervisor_id, suser.supervisor_attr_key, suser.supervisor_id, suser.supervisor_unique_id, suser.unique_user_id, suser.user_id, suser.business_unit, suser.collected_entity, suser.effective_entity, suser.identity_source, suser.sversion, suser.workforce_id, suser.photo_uri, suser.photo_format, suser.photo_record, suser.risk, ds.name, suser.affiliated_id
          ORDER BY suser.effective) su
     LEFT JOIN suser sus2 ON sus2.unique_user_id::text = su.unique_user_id::text AND sus2.effective = true
     LEFT JOIN suser sus ON sus.collected_entity = sus2.collected_entity AND sus.effective = false
     LEFT JOIN suser_email semail ON semail.suser = sus.id
     LEFT JOIN entity_change ec ON ec.unique_id::text = su.unique_user_id::text AND ec.change_type::text = 'ALTERED'::text
  GROUP BY su.id, sus.id, su.deleted, sus.deleted, su.department, sus.department, su.display_description, sus.display_description, su.display_name, sus.display_name, su.dn, sus.dn, su.effective, sus.effective, su.email, semail.email, su.employee_status, sus.employee_status, su.employee_type, sus.employee_type, su.first_name, sus.first_name, su.full_name, sus.full_name, su.guid, sus.guid, su.home_phone, sus.home_phone, su.idm_dn, sus.idm_dn, su.idm_tree_name, sus.idm_tree_name, su.is_curated, sus.is_curated, su.job_code, sus.job_code, su.job_title, sus.job_title, su.last_name, sus.last_name, su.location, sus.location, su.merged, sus.merged, su.middle_name, sus.middle_name, su.office_phone, sus.office_phone, su.other_phone, sus.other_phone, su.preferred_locale, sus.preferred_locale, su.provisioning_id, sus.provisioning_id, su.risk, sus.risk, su.secondary_supervisor_id, sus.secondary_supervisor_id, su.supervisor_attr_key, sus.supervisor_attr_key, su.supervisor_id, sus.supervisor_id, su.supervisor_unique_id, sus.supervisor_unique_id, su.unique_user_id, sus.unique_user_id, su.user_id, sus.user_id, su.business_unit, sus.business_unit, su.collected_entity, sus.collected_entity, su.effective_entity, sus.effective_entity, su.identity_source, sus.identity_source, su.sversion, sus.sversion, su.workforce_id, sus.workforce_id, su.photo_uri, sus.photo_uri, su.photo_format, sus.photo_format, su.photo_record, sus.photo_record, su.identity_source_name, su.affiliated_id, sus.affiliated_id
  ORDER BY sus.display_name;

ALTER TABLE public.suser_data_update_v
  OWNER TO igops;
GRANT ALL ON TABLE public.suser_data_update_v TO igops;
GRANT SELECT ON TABLE public.suser_data_update_v TO ig_report_role;
